<template>
  <q-card class="q-mt-sm">
    <q-card-section>
      <div class="row q-col-gutter-xs">
        <div class="col-12">
          <div class="q-gutter-md">
            <q-input
              v-model="formData.nombre"
              label="Nombre"
              :error="validacion.has('nombre')"
              :error-message="validacion.first('nombre')"
            >
              <template v-slot:prepend>
                <q-icon name="maps_home_work" />
              </template>
            </q-input>

            <q-input
              v-model="formData.direccion"
              label="Direccion"
              :error="validacion.has('direccion')"
              :error-message="validacion.first('direccion')"
            >
              <template v-slot:prepend>
                <q-icon name="signpost" />
              </template>
            </q-input>

            <q-input
              v-model="formData.localidad"
              label="Localidad"
              :error="validacion.has('localidad')"
              :error-message="validacion.first('localidad')"
            >
              <template v-slot:prepend>
                <q-icon name="alternate_email" />
              </template>
            </q-input>

            <q-input
              v-model="formData.telefono"
              label="Telefono"
              :error="validacion.has('telefono')"
              :error-message="validacion.first('telefono')"
            >
              <template v-slot:prepend>
                <q-icon name="call" />
              </template>
            </q-input>

            <q-input
              v-model="formData.maps"
              label="Link Maps"
              :error="validacion.has('maps')"
              :error-message="validacion.first('maps')"
            >
              <template v-slot:prepend>
                <q-icon name="location_on" />
              </template>
            </q-input>
            <q-input
              v-model="formData.comentario"
              label="Comentario"
              :error="validacion.has('comentario')"
              :error-message="validacion.first('comentario')"
              type="textarea"
            >
              <template v-slot:prepend>
                <q-icon name="question_answer" />
              </template>
            </q-input>
          </div>
        </div>
      </div>

      <div class="row q-col-gutter-xs q-mt-sm">
        <div class="col-12">
          <q-btn
            v-if="formData.uuid"
            @click="submitUpdate"
            class="full-width"
            color="green"
          >
            Actualizar lugar
          </q-btn>
          <q-btn
            v-if="!formData.uuid"
            @click="submitCrear"
            class="full-width"
            color="green"
          >
            Crear nuevo lugar
          </q-btn>
        </div>
      </div>

      <Loading :showing="loading" :text="loading_text" />
    </q-card-section>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRoute, useRouter } from 'vue-router';
import { LugaresInterface } from 'src/interfaces/EventosInterface';
import Loading from 'src/components/Loading.vue';

export default defineComponent({
  name: 'EventosLugarFormularioPage',
  components: { Loading },
  setup() {
    // const router = useRouter();
    const router = useRouter();
    const route = useRoute();
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    const loading = ref(false);
    const loading_text = ref<string>('Obteniendo Datos');

    const formData = ref({
      uuid: null,
      nombre: null,
      direccion: null,
      localidad: null,
      telefono: null,
      comentario: null,
      maps: null,
    });

    onMounted(() => {
      if (uuid != '') {
        // si paso un uuid, primero tengo que obtener el evento, para saber que tipo de area es
        getDatos();
      }
    });

    function getDatos() {
      loading.value = true;
      api
        .get<LugaresInterface>('/api/eventos/lugar/' + uuid)
        .then((response: AxiosResponse) => {
          formData.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitCrear() {
      loading_text.value = 'Enviando Datos';
      loading.value = true;
      api
        .post('/api/eventos/lugar', formData.value)
        .then(() => {
          router.push({ path: '/eventos/lugares' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitUpdate() {
      loading_text.value = 'Enviando Datos';

      loading.value = true;
      api
        .put('/api/eventos/lugar', formData.value)
        .then(() => {
          router.push({ path: '/eventos/lugares' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      validacion,
      loading,
      loading_text,
      formData,
      submitCrear,
      submitUpdate,
    };
  },
});
</script>
